Index: /trunk/doc/Flair/search/functions_2.js
===================================================================
--- /trunk/doc/Flair/search/functions_2.js	(revision 67)
+++ /trunk/doc/Flair/search/functions_2.js	(revision 68)
@@ -323,5 +323,5 @@
   ['colorspec',['colorSpec',['http://qt-project.org/doc/qt-4.8/qapplication.html#colorSpec',0,'QApplication']]],
   ['colortable',['colorTable',['http://qt-project.org/doc/qt-4.8/qimage.html#colorTable',0,'QImage']]],
-  ['cols',['Cols',['../classflair_1_1core_1_1cvmatrix.html#a66f244158d65f5cbfe4fd3cbb2452fa9',1,'flair::core::cvmatrix::Cols()'],['../classflair_1_1core_1_1cvmatrix__descriptor.html#ab27faf7fde9bbe28037e7f7e435cc7c8',1,'flair::core::cvmatrix_descriptor::Cols()']]],
+  ['cols',['Cols',['../classflair_1_1core_1_1cvmatrix.html#a66f244158d65f5cbfe4fd3cbb2452fa9',1,'flair::core::cvmatrix::Cols()'],['../classflair_1_1core_1_1cvmatrix__descriptor.html#ab27faf7fde9bbe28037e7f7e435cc7c8',1,'flair::core::cvmatrix_descriptor::Cols()'],['../classflair_1_1core_1_1_matrix.html#ad14d9ef66bd0148dea7b15fdaf966898',1,'flair::core::Matrix::Cols()']]],
   ['colspacing',['colSpacing',['http://qt-project.org/doc/qt-4.8/qgridlayout-qt3.html#colSpacing',0,'QGridLayout']]],
   ['colspan',['colSpan',['http://qt-project.org/doc/qt-4.8/q3tableitem.html#colSpan',0,'Q3TableItem']]],
@@ -544,5 +544,5 @@
   ['copycollectionfile',['copyCollectionFile',['http://qt-project.org/doc/qt-4.8/qhelpenginecore.html#copyCollectionFile',0,'QHelpEngineCore']]],
   ['copycount',['copyCount',['http://qt-project.org/doc/qt-4.8/qprinter.html#copyCount',0,'QPrinter']]],
-  ['copydatas',['CopyDatas',['../classflair_1_1gui_1_1_map.html#a0ba61b1b5046688eb8cdbedde133fe58',1,'flair::gui::Map::CopyDatas()'],['../classflair_1_1gui_1_1_send_data.html#aac3294aeba6bc94162bc8a2c2da9decb',1,'flair::gui::SendData::CopyDatas()']]],
+  ['copydatas',['CopyDatas',['../classflair_1_1gui_1_1_map.html#a0ba61b1b5046688eb8cdbedde133fe58',1,'flair::gui::Map::CopyDatas()'],['../classflair_1_1core_1_1_matrix.html#aaacb1fde15f6421c634b3c93eba6133f',1,'flair::core::Matrix::CopyDatas()'],['../classflair_1_1gui_1_1_send_data.html#aac3294aeba6bc94162bc8a2c2da9decb',1,'flair::gui::SendData::CopyDatas()']]],
   ['copydatato',['copyDataTo',['http://qt-project.org/doc/qt-4.8/qmatrix4x4.html#copyDataTo',0,'QMatrix4x4::copyDataTo()'],['http://qt-project.org/doc/qt-4.8/qgenericmatrix.html#copyDataTo',0,'QGenericMatrix::copyDataTo()']]],
   ['copyfrom',['CopyFrom',['../classflair_1_1core_1_1_geo_coordinate.html#a7038d23d65f34b72ea0fad6c9ccb6c1a',1,'flair::core::GeoCoordinate']]],
Index: /trunk/doc/Flair/search/variables_8.js
===================================================================
--- /trunk/doc/Flair/search/variables_8.js	(revision 67)
+++ /trunk/doc/Flair/search/variables_8.js	(revision 68)
@@ -2,5 +2,5 @@
 [
   ['img',['img',['../classflair_1_1core_1_1cvimage.html#acdd6453c16a50621dd369eef7ac4a9c6',1,'flair::core::cvimage']]],
-  ['input',['input',['../classflair_1_1filter_1_1_control_law.html#a9877d488ad17a52affd8c68beca426d1',1,'flair::filter::ControlLaw']]],
+  ['input',['input',['../classflair_1_1filter_1_1_control_law.html#ab88bfe866cc8f9794bda115d57139ab8',1,'flair::filter::ControlLaw']]],
   ['inputdialogoptions',['InputDialogOptions',['http://qt-project.org/doc/qt-4.8/qinputdialog.html#InputDialogOptions-typedef',0,'QInputDialog']]],
   ['interfacefactory',['InterfaceFactory',['http://qt-project.org/doc/qt-4.8/qaccessible.html#InterfaceFactory-typedef',0,'QAccessible']]],
Index: /trunk/doc/Flair/search/variables_d.js
===================================================================
--- /trunk/doc/Flair/search/variables_d.js	(revision 67)
+++ /trunk/doc/Flair/search/variables_d.js	(revision 68)
@@ -7,4 +7,4 @@
   ['optimizationflags',['OptimizationFlags',['http://qt-project.org/doc/qt-4.8/qgraphicsview.html#OptimizationFlags-typedef',0,'QGraphicsView']]],
   ['options',['Options',['http://qt-project.org/doc/qt-4.8/qfiledialog.html#Options-typedef',0,'QFileDialog']]],
-  ['output',['output',['../classflair_1_1filter_1_1_control_law.html#aad8a67d158a1eda16ed53615e2511f97',1,'flair::filter::ControlLaw::output()'],['../classflair_1_1sensor_1_1_laser_range_finder.html#a0885828ecb3c295d3ace281c23422a92',1,'flair::sensor::LaserRangeFinder::output()'],['../classflair_1_1sensor_1_1_us_range_finder.html#ae1bbee21887937a4dee3e427e1c37605',1,'flair::sensor::UsRangeFinder::output()']]]
+  ['output',['output',['../classflair_1_1filter_1_1_control_law.html#ad0ec9102c1f3d5cea5e337ba02754f4b',1,'flair::filter::ControlLaw::output()'],['../classflair_1_1sensor_1_1_laser_range_finder.html#a937a6f3b5be14e11d6ec1d4ed252f163',1,'flair::sensor::LaserRangeFinder::output()'],['../classflair_1_1sensor_1_1_pressure_sensor.html#a4b5f87b5034879385ea5afee73893c50',1,'flair::sensor::PressureSensor::output()'],['../classflair_1_1sensor_1_1_us_range_finder.html#a63e66a79a89148a55dc32d10fed7ccab',1,'flair::sensor::UsRangeFinder::output()']]]
 ];
Index: /trunk/include/FlairCore/FindArgument.h
===================================================================
--- /trunk/include/FlairCore/FindArgument.h	(revision 68)
+++ /trunk/include/FlairCore/FindArgument.h	(revision 68)
@@ -0,0 +1,8 @@
+#ifndef FINDARGUMENT
+#define FINDARGUMENT
+
+#include <string>
+
+std::string FindArgument(std::string args,std::string arg,bool recquired);
+
+#endif // FINDARGUMENT
Index: /trunk/include/FlairCore/FrameworkManager.h
===================================================================
--- /trunk/include/FlairCore/FrameworkManager.h	(revision 67)
+++ /trunk/include/FlairCore/FrameworkManager.h	(revision 68)
@@ -107,6 +107,7 @@
   *
   * \param log_path path to store logs
-  */
-  void SetupLogger(std::string log_path);
+  * \param stackSize stack size in bytes for logging thread
+  */
+  void SetupLogger(std::string log_path,uint32_t stackSize=1024*32);
 	
 	/*!
Index: /trunk/include/FlairCore/Matrix.h
===================================================================
--- /trunk/include/FlairCore/Matrix.h	(revision 68)
+++ /trunk/include/FlairCore/Matrix.h	(revision 68)
@@ -0,0 +1,215 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file Matrix.h
+ * \brief Class defining a matrix
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2018/01/30
+ * \version 4.0
+ */
+
+#ifndef MATRIX_H
+#define MATRIX_H
+
+#include <io_data.h>
+#include <IODataElement.h>
+#include <cvmatrix_descriptor.h>
+
+class Matrix_impl;
+
+namespace flair {
+namespace core {
+
+/*! \class Matrix
+*
+* \brief Class defining a matrix
+* 
+*
+*/
+class Matrix : public io_data {
+public:
+  class Type : public DataType {
+  public:
+    Type(size_t _nbRows, size_t _nbCols, ScalarType const &_elementDataType)
+        : nbRows(_nbRows), nbCols(_nbCols), elementDataType(_elementDataType) {}
+    size_t GetSize() const {
+      return nbRows * nbCols * elementDataType.GetSize();
+    }
+    std::string GetDescription() const { return "matrix"; }
+    size_t GetNbRows() const { return nbRows; }
+    size_t GetNbCols() const { return nbCols; }
+    ScalarType const &GetElementDataType() const { return elementDataType; }
+
+  private:
+    size_t nbRows, nbCols;
+    ScalarType const &elementDataType;
+  };
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct an io_data representing a matrix. \n
+  * It uses a cvmatrix_descriptor to get size and elements' names. \n
+  * Names are used for graphs and logs. \n
+  * All values are initialized to 0.
+  *
+  * \param parent parent
+  * \param descriptor matrix description, it is safe to destroy it after calling this constructor
+  * \param type type of matrix elements
+  * \param name name
+  * \param n number of samples
+  */
+  Matrix(const Object *parent, const cvmatrix_descriptor *descriptor,
+           ScalarType const &elementDataType, std::string name = "",
+           uint32_t n = 1);
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct an io_data representing a matrix. \n
+  * Elements are unamed. \n
+  * All values are initialized to 0.
+  *
+  * \param parent parent
+  * \param rows matrix rows
+  * \param cols matrix cols
+  * \param type type of matrix elements
+  * \param name name
+  * \param n number of samples
+  */
+  Matrix(const Object *parent, uint32_t rows, uint32_t cols,
+           ScalarType const &elementDataType, std::string name = "",
+           uint32_t n = 1);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Matrix();
+
+  /*!
+  * \brief Element value
+  *
+  * Element is accessed by locking and unlocking the io_data Mutex.
+  *
+  * \param row element row
+  * \param col element col
+  *
+  * \return element value
+  */
+  float Value(uint32_t row, uint32_t col) const;
+
+  /*!
+  * \brief Element value
+  *
+  * Element is not accessed by locking and unlocking the io_data Mutex. \n
+  * Thus, this function should be called with Mutex locked. \n
+  * This function is usefull when multiple successive access are done to the
+  * elments of the matrix. It avoids unnecessary locking and unlocking.
+  *
+  * \param row element row
+  * \param col element col
+  *
+  * \return element value
+  */
+  float ValueNoMutex(uint32_t row, uint32_t col) const;
+
+  /*!
+  * \brief Set element value
+  *
+  * Element is accessed by locking and unlocking the io_data Mutex.
+  *
+  * \param row element row
+  * \param col element col
+  * \param value element value
+  */
+  void SetValue(uint32_t row, uint32_t col, float value);
+
+  /*!
+  * \brief Set element value
+  *
+  * Element is not accessed by locking and unlocking the io_data Mutex. \n
+  * Thus, this function should be called with Mutex locked. \n
+  * This function is usefull when multiple successive access are done to the
+  * elments of the matrix. It avoids unnecessary locking and unlocking.
+  *
+  * \param row element row
+  * \param col element col
+  * \param value element value
+  */
+  void SetValueNoMutex(uint32_t row, uint32_t col, float value);
+
+  /*!
+  * \brief Element name
+  *
+  * If Matrix was created without cvmatrix_descriptor, element name is empty.
+  *
+  * \param row element row
+  * \param col element col
+  *
+  * \return element name
+  */
+  std::string Name(uint32_t row, uint32_t col) const;
+
+  /*!
+  * \brief Element
+  *
+  * Get a pointer to a specific element. This pointer can be used for plotting.
+  *
+  * \param row element row
+  * \param col element col
+  *
+  * \return pointer to the element
+  */
+  IODataElement *Element(uint32_t row, uint32_t col) const;
+
+  /*!
+  * \brief Element
+  *
+  * Get a pointer to a specific element. This pointer can be used for plotting.
+  *\n
+  * This function can be used for a 1D matrix.
+  *
+  * \param index element index
+  *
+  * \return pointer to the element
+  */
+  IODataElement *Element(uint32_t index) const;
+
+  /*!
+  * \brief Number of rows
+  *
+  * \return rows
+  */
+  uint32_t Rows(void) const;
+
+  /*!
+  * \brief Number of colomns
+  *
+  * \return colomns
+  */
+  uint32_t Cols(void) const;
+
+  Type const &GetDataType() const { return dataType; };
+void CopyDatas(char *dst) const;
+private:
+  /*!
+  * \brief Copy datas
+  *
+  * Reimplemented from io_data. \n
+  * See io_data::CopyDatas.
+  *
+  * \param dst destination buffer
+  */
+  //void CopyDatas(char *dst) const;
+
+  class Matrix_impl *pimpl_;
+  Type dataType;
+};
+
+} // end namespace core
+} // end namespace flair
+
+#endif // MATRIX_H
Index: /trunk/include/FlairCore/RangeFinderPlot.h
===================================================================
--- /trunk/include/FlairCore/RangeFinderPlot.h	(revision 67)
+++ /trunk/include/FlairCore/RangeFinderPlot.h	(revision 68)
@@ -20,5 +20,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 }
@@ -61,5 +61,5 @@
                   std::string x_name, float xmin, float xmax,
                   std::string y_name, float ymin, float ymax,
-                  const core::cvmatrix *datas, float start_angle,
+                  const core::Matrix *datas, float start_angle,
                   float end_angle, uint32_t nb_samples);
 
@@ -87,5 +87,5 @@
   void ExtraXmlEvent(void){};
 
-  const core::cvmatrix *datas;
+  const core::Matrix *datas;
 };
 
Index: /trunk/include/FlairCore/Thread.h
===================================================================
--- /trunk/include/FlairCore/Thread.h	(revision 67)
+++ /trunk/include/FlairCore/Thread.h	(revision 68)
@@ -46,7 +46,8 @@
   * \param name name
   * \param priority priority, should be >20 (<20 is reserved for internal use)
+  * \param stackSize stack size in bytes
   */
   Thread(const Object *parent, std::string name,
-         uint8_t priority); // priority>20, for real time only
+         uint8_t priority,uint32_t stackSize=1024*128);
 
   /*!
Index: /trunk/include/FlairCore/UsSensorPlot.h
===================================================================
--- /trunk/include/FlairCore/UsSensorPlot.h	(revision 68)
+++ /trunk/include/FlairCore/UsSensorPlot.h	(revision 68)
@@ -0,0 +1,77 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file UsSensorPlot.h
+ * \brief Class displaying a plot for raw us sensor
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2018/02/21
+ * \version 4.0
+ */
+
+#ifndef USSENSORPLOT_H
+#define USSENSORPLOT_H
+
+#include <DataPlot.h>
+#include <stdint.h>
+
+namespace flair {
+namespace core {
+class Matrix;
+}
+}
+
+namespace flair {
+namespace gui {
+
+class LayoutPosition;
+
+/*! \class UsSensorPlot
+*
+* \brief Class displaying a plot for raw us sensor
+*
+*/
+class UsSensorPlot : private DataPlot {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a plot for raw us sensor at given place position.
+  *
+  * \param position position to display the plot
+  * \param name name
+  * \param y_name name of y axis
+  * \param ymin default ymin of the plot
+  * \param ymax default ymax of the plot
+  * \param datas data matrix, must be 1D
+  * \param peakInfos peak infos, must be 1*4 (first start,first end, second start,second end)
+  */
+  UsSensorPlot(const LayoutPosition *position, std::string name,
+                       std::string y_name,float ymin, float ymax,const core::Matrix *datas,const core::Matrix *peakInfos);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~UsSensorPlot();
+  
+private:
+  /*!
+  * \brief Copy datas to specified buffer
+  *
+  * Reimplemented from SendData.
+  *
+  * \param buf output buffer
+  */
+  void CopyDatas(char *buf) const;
+  
+  const core::Matrix *datas,*peakInfos;
+
+
+};
+
+} // end namespace gui
+} // end namespace flair
+
+#endif // USSENSORPLOT_H
Index: /trunk/include/FlairCore/io_data.h
===================================================================
--- /trunk/include/FlairCore/io_data.h	(revision 67)
+++ /trunk/include/FlairCore/io_data.h	(revision 68)
@@ -116,16 +116,49 @@
 
   /*!
-  * \brief Set data time
-  *
+  * \brief Set data time, also caluculates the delta time based on last call
+  *
+  * TIME_INFINITE represents an unitialized time
+  * 
   * \param time time
   */
   void SetDataTime(Time time);
+  
+  /*!
+  * \brief Set data time and  delta time (thus delta time is not based on last call)
+  *
+  * TIME_INFINITE represents an unitialized time
+  * 
+  * \param time time
+  * \param deltaTime delta time
+  */
+  void SetDataTime(Time time,Time deltaTime);
 
   /*!
   * \brief Data time
   *
+  * TIME_INFINITE represents an unitialized time.
+  * 
   * \return data time
   */
   Time DataTime(void) const;
+  
+  /*!
+  * \brief Data delta time
+  *
+  * TIME_INFINITE represents an unitialized time.
+  * 
+  * \return data delta time
+  */
+  Time DataDeltaTime(void) const;
+  
+  /*!
+  * \brief Get data time and  delta time
+  *
+  * TIME_INFINITE represents an unitialized time
+  * 
+  * \param time time
+  * \param deltaTime delta time
+  */
+  void GetDataTime(Time &time,Time &deltaTime) const;
 
   /*!
Index: /trunk/include/FlairFilter/AhrsComplementaryFilter.h
===================================================================
--- /trunk/include/FlairFilter/AhrsComplementaryFilter.h	(revision 67)
+++ /trunk/include/FlairFilter/AhrsComplementaryFilter.h	(revision 68)
@@ -63,7 +63,4 @@
             void UpdateFrom(const core::io_data *data);
 
-            core::Time previous_time;
-
-            bool isInit;
             core::Quaternion QHat;
             core::Vector3Df BHat;
Index: /trunk/include/FlairFilter/ButterworthLowPass.h
===================================================================
--- /trunk/include/FlairFilter/ButterworthLowPass.h	(revision 67)
+++ /trunk/include/FlairFilter/ButterworthLowPass.h	(revision 68)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -91,5 +91,5 @@
   * \return filtered output
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
   /*!
Index: /trunk/include/FlairFilter/ControlLaw.h
===================================================================
--- /trunk/include/FlairFilter/ControlLaw.h	(revision 67)
+++ /trunk/include/FlairFilter/ControlLaw.h	(revision 68)
@@ -21,5 +21,5 @@
 }
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 }
@@ -88,5 +88,5 @@
   * \brief Reset the internal state of the control law
   *
-  * Doesn't do anything by default
+  * Does nothing by default
   *
   */
@@ -100,5 +100,5 @@
   *
   */
-  core::cvmatrix *input;
+  core::Matrix *input;
 
   /*!
@@ -109,5 +109,5 @@
   *
   */
-  core::cvmatrix *output;
+  core::Matrix *output;
 
 private:
Index: /trunk/include/FlairFilter/EulerDerivative.h
===================================================================
--- /trunk/include/FlairFilter/EulerDerivative.h	(revision 67)
+++ /trunk/include/FlairFilter/EulerDerivative.h	(revision 68)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -56,5 +56,5 @@
   EulerDerivative(const core::IODevice *parent,
                   const gui::LayoutPosition *position, std::string name,
-                  const core::cvmatrix *init_value = NULL);
+                  const core::Matrix *init_value = NULL);
 
   /*!
@@ -79,5 +79,5 @@
   * \return filtered output
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
 private:
Index: /trunk/include/FlairFilter/LowPassFilter.h
===================================================================
--- /trunk/include/FlairFilter/LowPassFilter.h	(revision 67)
+++ /trunk/include/FlairFilter/LowPassFilter.h	(revision 68)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -56,5 +56,5 @@
   LowPassFilter(const core::IODevice *parent,
                 const gui::LayoutPosition *position, std::string name,
-                const core::cvmatrix *init_value = NULL);
+                const core::Matrix *init_value = NULL);
 
   /*!
@@ -79,5 +79,5 @@
   * \return filtered output
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
 private:
Index: /trunk/include/FlairFilter/PidThrust.h
===================================================================
--- /trunk/include/FlairFilter/PidThrust.h	(revision 67)
+++ /trunk/include/FlairFilter/PidThrust.h	(revision 68)
@@ -55,4 +55,14 @@
 
   /*!
+  * \brief Reset the control law
+  * equivalent to:
+  * ResetI();
+  * SetDefaultOffset();
+  * SetValues(0,0);
+  * 
+  */
+  void Reset(void);
+  
+  /*!
   * \brief Reset integral to 0
   *
@@ -78,5 +88,12 @@
   * \return current offset
   */
-  float GetOffset(void);
+  float GetOffset(void) const;
+  
+  /*!
+  * \brief Get intergral part
+  *
+  * \return current integral part
+  */
+  float GetIntegral(void) const;
 
   /*!
Index: /trunk/include/FlairFilter/TrajectoryGenerator1D.h
===================================================================
--- /trunk/include/FlairFilter/TrajectoryGenerator1D.h	(revision 67)
+++ /trunk/include/FlairFilter/TrajectoryGenerator1D.h	(revision 68)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -152,5 +152,5 @@
   * \return matrix
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
 private:
Index: /trunk/include/FlairFilter/TrajectoryGenerator2DCircle.h
===================================================================
--- /trunk/include/FlairFilter/TrajectoryGenerator2DCircle.h	(revision 67)
+++ /trunk/include/FlairFilter/TrajectoryGenerator2DCircle.h	(revision 68)
@@ -19,5 +19,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -131,5 +131,5 @@
   * \return matrix
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
   /*!
Index: /trunk/include/FlairMeta/Uav.h
===================================================================
--- /trunk/include/FlairMeta/Uav.h	(revision 67)
+++ /trunk/include/FlairMeta/Uav.h	(revision 68)
@@ -31,4 +31,5 @@
 		class Camera;
 		class NmeaGps;
+		class PressureSensor;
 	}
 }
@@ -64,4 +65,5 @@
   sensor::Camera *GetHorizontalCamera(void) const;
   sensor::NmeaGps *GetGps(void) const;
+  sensor::PressureSensor *GetPressureSensor(void) const;
 	virtual std::string GetDefaultVrpnAddress(void) const{return "127.0.0.1:3883";}
   virtual bool isReadyToFly(void) const { return true;}
@@ -77,4 +79,5 @@
   void SetHorizontalCamera(const sensor::Camera *verticalCamera);
   void SetGps(const sensor::NmeaGps *gps);
+  void SetPressureSensor(const sensor::PressureSensor *pressureSensor);
 
 private:
@@ -88,4 +91,5 @@
   sensor::BatteryMonitor *battery;
   sensor::Camera *verticalCamera,*horizontalCamera;
+  sensor::PressureSensor *pressureSensor;
 };
 
Index: /trunk/include/FlairSensorActuator/BlCtrlV2_x4_speed.h
===================================================================
--- /trunk/include/FlairSensorActuator/BlCtrlV2_x4_speed.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/BlCtrlV2_x4_speed.h	(revision 68)
@@ -24,5 +24,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 class I2cPort;
 }
@@ -97,6 +97,6 @@
 
   // matrix
-  core::cvmatrix *input;
-  core::cvmatrix *output;
+  core::Matrix *input;
+  core::Matrix *output;
 
   int tested_motor;
Index: /trunk/include/FlairSensorActuator/Bldc.h
===================================================================
--- /trunk/include/FlairSensorActuator/Bldc.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/Bldc.h	(revision 68)
@@ -19,5 +19,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -96,5 +96,5 @@
   *
   */
-  core::cvmatrix *Output(void) const;
+  core::Matrix *Output(void) const;
 
   /*!
@@ -161,5 +161,5 @@
 
 protected:
-  core::cvmatrix *output;
+  core::Matrix *output;
 
 private:
Index: /trunk/include/FlairSensorActuator/EmulatedController.h
===================================================================
--- /trunk/include/FlairSensorActuator/EmulatedController.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/EmulatedController.h	(revision 68)
@@ -21,5 +21,5 @@
 namespace flair {
     namespace core {
-        class cvmatrix;
+        class Matrix;
     }
     namespace gui {
@@ -52,17 +52,17 @@
         bool ProcessMessage(core::Message *msg);
         bool IsDataFrameReady();
-        void AcquireAxisData(core::cvmatrix &axis); //responsible for getting the axis data from the hardware
-        void AcquireButtonData(core::cvmatrix &button); //responsible for getting the button data from the hardware
+        void AcquireAxisData(core::Matrix &axis); //responsible for getting the axis data from the hardware
+        void AcquireButtonData(core::Matrix &button); //responsible for getting the button data from the hardware
         bool ControllerInitialization();
 
     private:
         enum class DataType { axis,button };
-        void ComputeControllerData(DataType dataType, core::cvmatrix &data);
-        template<typename T> void fillVectorNoMutex(core::cvmatrix &vector,T data[],unsigned int size);
-        void fillVectorNoMutex(core::cvmatrix &destination,core::cvmatrix &source,unsigned int size);
+        void ComputeControllerData(DataType dataType, core::Matrix &data);
+        template<typename T> void fillVectorNoMutex(core::Matrix &vector,T data[],unsigned int size);
+        void fillVectorNoMutex(core::Matrix &destination,core::Matrix &source,unsigned int size);
         struct StepData {
             unsigned int durationMs; //milliseconds
-            core::cvmatrix *axisData;
-            core::cvmatrix *buttonData;
+            core::Matrix *axisData;
+            core::Matrix *buttonData;
             std::string description;
             void Print();
Index: /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h
===================================================================
--- /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/HokuyoUTM30Lx.h	(revision 68)
@@ -23,5 +23,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 class SerialPort;
 class Mutex;
@@ -56,5 +56,5 @@
   void getMesure(int startStep, int endStep, int clusterCount, int interval,
                  int scanNumber = 0);
-  core::cvmatrix *getDatas(void);
+  core::Matrix *getDatas(void);
 
   /*!
@@ -78,5 +78,5 @@
 
   // matrix
-  core::cvmatrix *output;
+  core::Matrix *output;
 
   std::queue<std::string> bufRet;
Index: /trunk/include/FlairSensorActuator/HostEthController.h
===================================================================
--- /trunk/include/FlairSensorActuator/HostEthController.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/HostEthController.h	(revision 68)
@@ -26,5 +26,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 class TcpSocket;
 class UdpSocket;
@@ -81,5 +81,5 @@
   GetAxisData() = 0; // responsible for getting the axis data from the hardware
   unsigned int axisNumber;
-  core::cvmatrix *axis;
+  core::Matrix *axis;
   gui::DataPlot1D **axisPlot;
   uint32_t bitsPerAxis;
@@ -90,5 +90,5 @@
                                     // from the hardware
   unsigned int buttonNumber;
-  core::cvmatrix *button;
+  core::Matrix *button;
   uint8_t buttonOffset;
   bool meaningfulDataAvailable;
Index: /trunk/include/FlairSensorActuator/LaserRangeFinder.h
===================================================================
--- /trunk/include/FlairSensorActuator/LaserRangeFinder.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/LaserRangeFinder.h	(revision 68)
@@ -19,5 +19,5 @@
 namespace core {
 class FrameworkManager;
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -102,5 +102,5 @@
       * \return output matrix
       */
-  core::cvmatrix *output;
+  core::Matrix *output;
 
   /*!
Index: /trunk/include/FlairSensorActuator/PressureSensor.h
===================================================================
--- /trunk/include/FlairSensorActuator/PressureSensor.h	(revision 68)
+++ /trunk/include/FlairSensorActuator/PressureSensor.h	(revision 68)
@@ -0,0 +1,149 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file PressureSensor.h
+ * \brief Base class for PressureSensor
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2018/02/08
+ * \version 4.0
+ */
+
+#ifndef PRESSURESENSOR_H
+#define PRESSURESENSOR_H
+
+#include <IODevice.h>
+
+namespace flair {
+  namespace core {
+    class Matrix;
+  }
+  namespace gui {
+    class Tab;
+    class TabWidget;
+    class GroupBox;
+    class Layout;
+    class DataPlot1D;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class PressureSensor
+*
+* \brief Base class for PressureSensor
+*
+* Use this class to define a custom PressureSensor.
+*
+*/
+class PressureSensor : public core::IODevice {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a PressureSensor. Control part.
+	* It will be child of the FrameworkManager.
+	* 
+  * \param name name
+  */
+  PressureSensor(std::string name);
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct a PressureSensor. Simulation part.
+  *
+  * \param parent parent
+  * \param name name
+  */
+  PressureSensor(const core::IODevice *parent, std::string name);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~PressureSensor();
+
+  /*!
+  * \brief Lock user interface
+  *
+  */
+  void LockUserInterface(void) const;
+
+  /*!
+  * \brief Unlock user interface
+  *
+  */
+  void UnlockUserInterface(void) const;
+
+  /*!
+  * \brief Use default plot
+  *
+  * Should no be used for the simulation part.
+  */
+  void UseDefaultPlot(void);
+
+  /*!
+  * \brief Plot
+  *
+  * \return DataPlot1D
+  */
+  gui::DataPlot1D *GetPlot(void) const;
+
+  /*!
+  * \brief Setup Layout
+  *
+  * \return a Layout available
+  */
+  gui::Layout *GetLayout(void) const;
+
+  /*!
+  * \brief Plot tab
+  *
+  * \return plot Tab
+  */
+  gui::Tab *GetPlotTab(void) const;
+
+  /*!
+  * \brief Value
+  *
+  * \return output value in pascal
+  */
+  float Value(void) const;
+
+protected:
+  /*!
+  * \brief Output matrix
+  *
+  * \return output matrix
+  */
+  core::Matrix *output;
+
+  /*!
+  * \brief Setup GroupBox
+  *
+  * \return a GroupBox available
+  */
+  gui::GroupBox *GetGroupBox(void) const;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  gui::Tab *main_tab;
+  gui::TabWidget *tab;
+  gui::GroupBox *setup_groupbox;
+  gui::Tab *sensor_tab;
+  gui::DataPlot1D *plot;
+  gui::Tab *plot_tab;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // PRESSURESENSOR_H
Index: /trunk/include/FlairSensorActuator/RadioReceiver.h
===================================================================
--- /trunk/include/FlairSensorActuator/RadioReceiver.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/RadioReceiver.h	(revision 68)
@@ -19,5 +19,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -87,5 +87,5 @@
   void UpdateFrom(const core::io_data *data){};
 
-  core::cvmatrix *output;
+  core::Matrix *output;
   bool is_connected;
   unsigned int nb_channels;
Index: /trunk/include/FlairSensorActuator/SimuBldc.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuBldc.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuBldc.h	(revision 68)
@@ -20,5 +20,5 @@
 class SharedMem;
 class IODevice;
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -40,5 +40,5 @@
   * \brief Constructor
   *
-  * Construct a SimuBldc. Control part.
+  * Construct a SimuBldc
   *
   * \param parent parent
@@ -53,31 +53,8 @@
 
   /*!
-  * \brief Constructor
-  *
-  * Construct a SimuBldc. Simulation part.
-  *
-  * \param parent parent
-  * \param name name
-  * \param motors_count number of motors
-  * \param modelId Model id
-  * \param deviceId Bldc id of the Model
-  */
-  SimuBldc(const core::Object *parent, std::string name, uint8_t motors_count,
-           uint32_t modelId,uint32_t deviceId);
-
-  /*!
   * \brief Destructor
   *
   */
   ~SimuBldc();
-
-  /*!
-  * \brief Get motors speeds.
-  *
-  * This function should only be used for the simulation part.
-  *
-  * \param value array to store motors speeds
-  */
-  void GetSpeeds(float *value) const;
 
   /*!
@@ -113,4 +90,6 @@
   core::SharedMem *shmem;
   gui::DoubleSpinBox *k;
+  char *buf;
+
 };
 } // end namespace actuator
